// ---------------------------------------------------------- 
//  (C)1994 Institute for New Generation Computer Technology 
//      (Read COPYRIGHT for detailed information.) 
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <stream.h>
#include <string.h>
#include <ctype.h>
#include "../amino/amino.h"
#include "../mssd/mssd.h"
#include "astar.h"
#include "alignInverse.h"

main(int ArgCnt, char** ArgVal)
{
  if(ArgCnt<4)
    {
      cerr << form("Too few arguments!\nUsage\n%s [sequence file] [gap cost] [slide cost]\n",ArgVal[0]);
      exit(1);
    }
  FILE* SeqFile;
  if(NULL==(SeqFile=fopen(ArgVal[1],"r")))
    {
      cerr << form("Can't open file %s.\n",ArgVal[1]);
      exit(1);
    }
  char BuffLine[1024];

  double GapPenalty   = atof(ArgVal[2]);
  double SlidePenalty = atof(ArgVal[3]);
  if(NULL==fgets(BuffLine,1023,SeqFile))
    {
      cerr << "Invalid Sequence File!\n";
      exit(1);
    }
  char PDBEntName[8];
  int I = 0;
  while(BuffLine[I] != ':')
    {
      PDBEntName[I] = BuffLine[I++];
    }
  PDBEntName[I] = '\0';
  cerr << PDBEntName << '\n';
  int Size = strlen(BuffLine+I+1)*strlen(BuffLine+I+1);
  initFreeMapPosition(Size);
  initFreeNode(Size);

  alignProfile Align(stdin,BuffLine+I+1,GapPenalty,SlidePenalty);
  node* GoalNode = Align.astarSearch();
  double ScoreWithoutGaps = Align.showAlignment(GoalNode);
//Align.showNodeCntMap();
  printf("Seq %s Profile %s: %10.5lf %10.5lf\n",PDBEntName,
	 Align.structId(),
	 Align.actualScore(GoalNode),ScoreWithoutGaps);
}
