// ---------------------------------------------------------- 
//  (C)1994 Institute for New Generation Computer Technology 
//      (Read COPYRIGHT for detailed information.) 
//-----------------------------------------------------------

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stream.h>
#include "../wavelet/wavelet.h"
#include "mssd.h"
#include "geom.h"

main(int ArgCnt,char** ArgVal)
{
  if(ArgCnt<2)
    {
      cerr << "Too few Arguments!\n";
      cerr << form("Usage:\n%s [MSSDData]\n",ArgVal[0]);
      exit(1);
    }

  FILE* MSSDFile;
  if(NULL==(MSSDFile=fopen(ArgVal[1],"r")))
    {
      cerr << "Can't open MSSDData File!\n";
      exit(1);
    }

  hyperGeomStat* HyperGeomStatsA = new hyperGeomStat[NumberOfLevels];
  hyperGeomStat* HyperGeomStatsB = new hyperGeomStat[NumberOfLevels];
  hyperGeomStat* HyperGeomStats1 = new hyperGeomStat[NumberOfLevels-1];
  hyperGeomStat* HyperGeomStats2 = new hyperGeomStat[NumberOfLevels-2];

  for(int L=0;L<NumberOfLevels;++L)
    {
      HyperGeomStatsA[L].init(L,L,L,0,-1,1);
      HyperGeomStatsB[L].init(L,L,L,0,-LevelWidth[L]/4,LevelWidth[L]/4);
    }
  for(    L=0;L<NumberOfLevels-1;++L)
    {
      HyperGeomStats1[L].init(L+1,L,L,0,0,LevelWidth[L+1]-LevelWidth[L]);
    }
  for(    L=0;L<NumberOfLevels-2;++L)
    {
      HyperGeomStats2[L].init(L+2,L,L,0,0,LevelWidth[L+2]-LevelWidth[L]);
    }

  while(1)
    {
      mssd MSSD;
      if(0==MSSD.read(MSSDFile))
	break;
      for(L=0;L<NumberOfLevels;++L)
	{
	  HyperGeomStatsA[L].push(&MSSD);
	}
      for(L=0;L<NumberOfLevels;++L)
	{
	  HyperGeomStatsB[L].push(&MSSD);
	}
      for(L=0;L<NumberOfLevels-1;++L)
	{
	  HyperGeomStats1[L].push(&MSSD);
	}
      for(L=0;L<NumberOfLevels-2;++L)
	{
	  HyperGeomStats2[L].push(&MSSD);
	}
    }
  fclose(MSSDFile);
  for(    L=0;L<NumberOfLevels;++L)
    {
      HyperGeomStatsA[L].print();
    }
  for(    L=0;L<NumberOfLevels;++L)
    {
      HyperGeomStatsB[L].print();
    }
  for(    L=0;L<NumberOfLevels-1;++L)
    {
      HyperGeomStats1[L].print();
    }
  for(    L=0;L<NumberOfLevels-2;++L)
    {
      HyperGeomStats2[L].print();
    }
}
